// Author : Pierre Vuillemin (2016)
// License : GNU GPL

function [out,err] = %sopiProp_e(varargin)
   // Overloading of the extraction for a sopiProp
   //
   err = %F
   p = varargin($)
   if length(varargin) == 2 & typeof(varargin(1)) == 'string' then
      field             = varargin(1)
      validFieldNames   = fieldnames(p)
      if or(field == validFieldNames) then
         out = getfield(field, p)
      else
         [out,err] = sopi_performPropTest(p,field)
      end
   else
      error('Invalid extraction')
   end
endfunction

function [out, err] = sopi_performPropTest(p, field)
   sopi_loadPropConstants()
   //
   field = convstr(field,'l')
   //
   err   = %F
   out   = %F
   select field
   case 'ispoly'
      if or(p.sets == RAT)
         out = p.data.dorder == 0
      end
   case 'israt'
      if or(p.sets == RAT)
         out = p.data.dorder >0
      end
   case 'polyorder'
      out = p.data.norder
   case 'isdiff'
      out =  or(p.sets == DIFF)
   case 'issmooth'
      out =  or(p.sets == SMOOTH)
   case 'isconvex'
      out =  or(p.sets == CONVEX)
   case 'isconcave'
      out =  or(p.sets == CONCAVE)
   case 'isconstant'
      if p.isPoly
         out = p.polyOrder == 0
      end
   case 'islinear'
      if p.isPoly
         out = p.polyOrder == 1
      end
   case 'ispw'
      out = or(p.sets == PW)
   case 'isnl'
      out = ~p.isPoly & ~p.isRat & ~p.isConvex
   case 'ispositive'
      out = or(p.sets == POSITIVE)
   case 'isnegative'
      out = or(p.sets == NEGATIVE)
   else
      err = %T
   end
endfunction
