// Author : Pierre Vuillemin (2016)
// License : GNU GPL

function rule = sopi_newRule(rt, varargin)
   objType  = 'sopiRule';
   objAtt   = list('ruleType',rt);
   if rt=='all'
      // sopi_newRule('all', list([s1;s2],[s3;s4]),sout,postAction) tests each
      // argument. For the precondition to be valid, each argument should satisfy
      // s1 & s2 | s3 & s4, then the output arg gain sout, and the postAction
      // if performed.
      if typeof(varargin(1)) == 'string'
         sets = list(varargin(1))
      else
         sets = varargin(1)
      end
      speObjAtt = list('sets', sets, 'out', varargin(2),'postAction',[])
      if length(varargin) == 3
         speObjAtt($) = varargin(3)
      end
   elseif rt =='comp'
      speObjAtt = list('sets1',varargin(1),'sets2',varargin(2),'out',varargin(3))
   elseif rt =='incond'
      speObjAtt = list('out',varargin(1))
   end
   rule     = sopi_makeObject(objType, lstcat(objAtt,speObjAtt));
endfunction
