// Author : Pierre Vuillemin (2016)
// License : GNU GPL

function %sopiPro_p(problem)
   titl     = 'Optimisation problem'
   headers  = list('','')
   entries  = list('Class', sopi_verboseProblemClass(problem.class),...
                   'Number of variables', problem.nvar,...
                   '#Constraints',problem.nc)
   if problem.nlb~=0 then
      entries($+1) = 'Lower bounds'
      entries($+1) = problem.nlb
   end
   if problem.nub~=0 then
      entries($+1) = 'Upper bounds'
      entries($+1) = problem.nub
   end
   if problem.nlic~=0 then
      entries($+1) = 'Linear inequalities'
      entries($+1) = problem.nlic
   end
   if problem.nlec~=0 then
      entries($+1) = 'Linear equalities'
      entries($+1) = problem.nlec
   end
   if problem.nnlic~=0 then
      entries($+1) = 'Nonlinear inequalities'
      entries($+1) = problem.nnlic
   end
   if problem.nnlec~=0 then
      entries($+1) = 'Nonlinear equalities'
      entries($+1) = problem.nnlec
   end
   entries($+1) = '#Available solvers'
   entries($+1) = length(problem.solvers)

   for i = 1:length(problem.solvers)
      entries($+1) = ''
      entries($+1) = problem.solvers(i).name
   end
   if ~isempty(problem.name) then
      entries(0) = problem.name
      entries(0) = 'Name'
   end
   tab = sopi_tabular(titl, headers, entries)
   mprintf(tab)
endfunction
