// Author : Pierre Vuillemin (2016)
// License : GNU GPL

function pos = sopi_findVarPosInList(var,varList)
   // Finds the index of a variable in a list of variables.
   //
   // Calling Sequence
   //    pos = sopi_findVarPosInList(var, varList)
   //
   // Parameters
   //    var      : variable to look for (sopiVar)
   //    varList  : list of variables (list)
   //    post     : the index of the variable in the list (integer)
   //
   // Description
   //    The output is empty when the variable is not in the list
   pos = [];
   for j = 1:length(varList)
      if var.id == varList(j).id
         pos = j;
      end
   end
endfunction
