// Author : Pierre Vuillemin (2016)
// License : GNU GPL

function out = sopi_jac(var, refvars)
   out = list()
   if argn(2) < 2 then
      refvars = var.depends
   end

   for rv = refvars
      out($+1) = sopi_recJac(var, rv)
   end
endfunction

function out = sopi_recJac(var, refvar)
   if var.isElementary then
      if var.id == refvar.id
         [m,n] = size(var)
         out   = eye(m,n)
      else
         out = 0
      end
   else
      select var.operator
      case 'constant'
         out = 0
      case 'sum'
         out = []
         for a = var.args
            out = out + sopi_recJac(a,refvar)
         end
      case 'times'
         out = sopi_recJac(var.args(1),refvar) * var.args(2) + var.args(1) * sopi_recJac(var.args(2),refvar)
      case 'hcat'
         out = []
         for a = var.args
            out = [out, sopi_recJac(a)]
         end
      case 'vcat'
         out = []
         for a = var.args
            out = [out; sopi_recJac(a)]
         end
      else
         error('not yet!!!')
      end

   end
endfunction
