// Copyright 2017 - Pierre Vuillemin
// License : GNU GPL

function problem = sopi_max(fun, varargin)
   // Creates a maximisation problem.
   //
   // Calling Sequence
   //    problem = sopi_min(fun)
   //    problem = sopi_min(fun, c1, ..., cn)
   //
   // Parameters
   //    fun      : the objective function (sopiVar)
   //    ci       : constraints (sopiCst or list of sopiCst)
   //    problem  : the optimisation problem (sopiPro)
   //
   // See also
   //    sopi_var
   //    sopi_min
   //    sopi_solve
   //    sopi_example
   //   
   problem = sopi_min(-fun, varargin(:))
endfunction
