// Author : Pierre Vuillemin (2017)
// License : GNU GPL

function [H,A,B] = sopi_extractQuadForm(var, problem)
   // TODO: finir
   if argn(2)<2 | isempty(problem) then
      // Emulating a sopi_problem to order variables
      varList           = var.depends
      [idxList, nvar]   = sopi_orderVariables(varList)
      problem           = struct('varList',varList,'varIdx',idxList, 'nvar', nvar)
   end
   // Second order term
   if and(size(var) == [1,1]) then
      nvar     = problem.nvar
      out      = sopi_extractPolyPart(var, 2)
      H        = zeros(nvar,nvar)
      for o = out
         // L * lvar * M * rvar * R
         L     = o(1)(1)
         M     = o(1)(2)
         R     = o(1)(3)
         //
         lvar  = o(2)(1)
         rvar  = o(2)(2)
         //
         if lvar.operator == "transpose"
            idxlvar = sopi_getVarIdxInProblem(problem, lvar.args(1))
         else
            // TODO: vérifier
            idxlvar = sopi_getVarIdxInProblem(problem, lvar)
         end
         idxrvar = sopi_getVarIdxInProblem(problem, rvar)
         H(idxlvar, idxrvar) = H(idxlvar, idxrvar) + M
      end
      H = 1/2 * (H + H')
   else
      error('Cannot extract quadratic form from matrix variable')
   end
   // Affine part
   if argn(1)==2 then
      A        = sopi_extractAffineForm(var, problem)
   elseif argn(1) == 3 then
      [A, B]   = sopi_extractAffineForm(var, problem)
   end
   if isempty(A) then
      A = zeros(1,size(H,1))
   end
   if isempty(B) then
      B = 0
   end
endfunction
