// Author : Pierre Vuillemin (2016)
// License : GNU GPL

function exStr = sopi_strToAssignTopVars(varNames, varValues)
   // Creates a string to be executed to assign variables in the calling scope.
   //
   // Calling Sequence
   //    exStr = sopi_strToAssignTopVars(varNames, varValues)
   //
   // Parameters
   //    varNames : names of the variables (array of string)
   //    varValues: names of the variables in the current scope that have the
   //               coresponding value (array of string)
   //    exStr    : string to execute (string)
   //
   // Example
   //    function inner()
   //       a_inner  = 1;
   //       b_inner  = 2;
   //       exStr    = sopi_strToAssignTopVars(['a_outer','b_outer'],['a_inner','b_inner']);
   //       execstr(exStr)
   //    endfunction
   //    inner()
   //    disp(a_outer)
   //    disp(b_outer)
   exStr = '[' + strcat(varNames,',') + '] = resume(' + strcat(varValues,',')+');'
endfunction
