// Author : Pierre Vuillemin (2016)
// License : GNU GPL

// sopi_extractPolyPart is meant to extract the coefficient of the monomial of 
// given order in a sopiVar. More specifically, it returns the coefficients ci
// and the variables vi such that
// c1 * v1 * c2 * v2 * ...* cn * vn * cn+1
sopi_begin()
//
n     = 3
x     = sopi_var(n,n)
// First order at most
A     = rand(n,n)
B     = rand(n,n)
z     = A*x + B
order = 0
out   = sopi_extractPolyPart(z,order)
assert_checktrue(out(1)(1)(1) == B)
order = 1
out   = sopi_extractPolyPart(z, order)
assert_checktrue(out(1)(1)(1) == A)
assert_checktrue(out(1)(1)(2) == eye(n,n))
assert_checktrue(out(1)(2)(1).id == x.id)
order = 2
out   = sopi_extractPolyPart(z, order)
assert_checktrue(isempty(out))
// Second order at most
C     = rand(n,n)
D     = rand(n,n)
E     = rand(n,n)
F     = rand(n,n)
y     = sopi_var(n,n)
z     = (A*x*B + C) * (D*y*E + F)
order = 0
out   = sopi_extractPolyPart(z,order)
assert_checktrue(out(1)(1)(1) == C*F)
order = 1
out   = sopi_extractPolyPart(z,order)
assert_checktrue(out(1)(1)(1) == A)
assert_checktrue(out(1)(1)(2) == B*F)
assert_checktrue(out(1)(2)(1).id == x.id)
assert_checktrue(out(2)(1)(1) == C*D)
assert_checktrue(out(2)(1)(2) == E)
assert_checktrue(out(2)(2)(1).id == y.id)
order = 2
out   = sopi_extractPolyPart(z,order)
assert_checktrue(out(1)(1)(1) == A)
assert_checktrue(out(1)(1)(2) == B*D)
assert_checktrue(out(1)(1)(3) == E)
assert_checktrue(out(1)(2)(1).id == x.id)
assert_checktrue(out(1)(2)(2).id == y.id)
